// HtmlViewExSite.h : header file
//
/////////////////////////////////////////////////////////////////////////////

#ifndef __HTMLVIEWEXSITE_H__
#define __HTMLVIEWEXSITE_H__

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

#ifndef __mshtmhst_h__
	#include <mshtmhst.h>
#endif


/////////////////////////////////////////////////////////////////////////////
// CHtmlViewExSite class
//

#undef	AFX_DATA
#define AFX_DATA

#ifndef DEFINED_OCCIMPL
#if _MSC_VER < 1300 			//+++ vcversionɂătH_Ⴄ...
#include <../src/occimpl.h>
#else							//+++ vcversionɂătH_Ⴄ...
//#include <../src/mfc/occimpl.h>	//+++
#include <afxocc.h> 			//+++ vc7ȍ~łvc6occimpl.hɓĂ`Ɨ͗l.
#endif
#define DEFINED_OCCIMPL
#endif

class CHtmlViewExSite : public COleControlSite
{

// Construction
public:
	CHtmlViewExSite(COleControlContainer *pCnt)
		: COleControlSite(pCnt)
	{
		// Default Settings
		m_bCustomHelp					= FALSE;
		m_bCustomMessage				= FALSE;
		m_bUseCustomContextMenu 		= FALSE;
		m_bAdvancedContextMenuHandler	= FALSE;
		m_bKillDialog					= FALSE;

		m_dwFlags		= 0;
		m_dwDoubleClick = DOCHOSTUIDBLCLK_DEFAULT;
	};

// Attributes
protected:
	// DOCHOSTUIINFO Holders
	DWORD	m_dwFlags;
	DWORD	m_dwDoubleClick;

	// Custom Help/Message Toggles
	BOOL	m_bCustomHelp;
	BOOL	m_bCustomMessage;
	BOOL	m_bKillDialog;
	BOOL	m_bUseCustomContextMenu;
	BOOL	m_bAdvancedContextMenuHandler;

public:
	// DOCHOSTUIINFO Holders Set/Get
	DWORD				GetHostInfo_Flags() const;
	void				SetHostInfo_Flags(DWORD flags);
	DWORD				GetHostInfo_DblClk() const;
	void				SetHostInfo_DblClk(DWORD DoubleClick);

	// Custom UI Toggles
	void				UseCustomHelp(BOOL bSet);
	void				UseCustomMessage(BOOL bSet);
	void				UseCustomContextMenu(BOOL bSet);
	void				UseAdvancedContextMenu(BOOL bSet);
	void				UseKillDialog(BOOL bSet);
public:
	// Helpers to get pointers to the document dispatch
	// and the attached view
	IDispatch*	GetDispatch() const;
	CView*			GetView() const;

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CHtmlViewExSite)
	//}}AFX_VIRTUAL

// Implementation
public:
	~CHtmlViewExSite();

#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

// Generated message map functions
protected:
	//{{AFX_MSG(CHtmlViewExSite)
		// NOTE - the ClassWizard will add and remove member functions here.
		//	  DO NOT EDIT what you see in these blocks of generated code !
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// IDocHostUIHandler Interface
protected:
	BEGIN_INTERFACE_PART(DocHostUIHandler, IDocHostUIHandler)
		INIT_INTERFACE_PART(CHtmlViewExSite, DocHostUIHandler)
		STDMETHOD(ShowContextMenu)(/* [in ] */ DWORD hWndID,
		/* [in ] */ POINT __RPC_FAR *ppt,
		/* [in ] */ IUnknown __RPC_FAR *pcmdtReserved,
		/* [in ] */ IDispatch __RPC_FAR *pdispReserved);
		STDMETHOD(GetHostInfo)(
		/* [out][in ] */ DOCHOSTUIINFO __RPC_FAR *pInfo);
		STDMETHOD(ShowUI)(
		/* [in ] */ DWORD dwID,
		/* [in ] */ IOleInPlaceActiveObject __RPC_FAR *pActiveObject,
		/* [in ] */ IOleCommandTarget __RPC_FAR *pCommandTarget,
		/* [in ] */ IOleInPlaceFrame __RPC_FAR *pFrame,
		/* [in ] */ IOleInPlaceUIWindow __RPC_FAR *pDoc);
		STDMETHOD(HideUI)(void);
		STDMETHOD(UpdateUI)(void);
		STDMETHOD(EnableModeless)(
		/* [in ] */ BOOL fEnable);
		STDMETHOD(OnDocWindowActivate)(
		/* [in ] */ BOOL fEnable);
		STDMETHOD(OnFrameWindowActivate)(
		/* [in ] */ BOOL fEnable);
		STDMETHOD(ResizeBorder)(
		/* [in ] */ LPCRECT prcBorder,
		/* [in ] */ IOleInPlaceUIWindow __RPC_FAR *pUIWindow,
		/* [in ] */ BOOL fRameWindow);
		STDMETHOD(TranslateAccelerator)(
		/* [in ] */ LPMSG lpMsg,
		/* [in ] */ const GUID __RPC_FAR *pguidCmdGroup,
		/* [in ] */ DWORD nCmdID);
		STDMETHOD(GetOptionKeyPath)(
		/* [out] */ LPOLESTR __RPC_FAR *pchKey,
		/* [in ] */ DWORD dw);
		STDMETHOD(GetDropTarget)(
		/* [in ] */ IDropTarget __RPC_FAR *pDropTarget,
		/* [out] */ IDropTarget __RPC_FAR *__RPC_FAR *ppDropTarget);
		STDMETHOD(GetExternal)(
		/* [out] */ IDispatch __RPC_FAR *__RPC_FAR *ppDispatch);
		STDMETHOD(TranslateUrl)(
		/* [in ] */ DWORD dwTranslate,
		/* [in ] */ OLECHAR __RPC_FAR *pchURLIn,
		/* [out] */ OLECHAR __RPC_FAR *__RPC_FAR *ppchURLOut);
		STDMETHOD(FilterDataObject)(
		/* [in ] */ IDataObject __RPC_FAR *pDO,
		/* [out] */ IDataObject __RPC_FAR *__RPC_FAR *ppDORet);
	END_INTERFACE_PART(DocHostUIHandler)

/////////////////////////////////////////////////////////////////////////////
// IDocHostShowUI Interface
protected:
	BEGIN_INTERFACE_PART(DocHostShowUI, IDocHostShowUI)
		INIT_INTERFACE_PART(CHtmlViewExSite, DocHostShowUI)
		STDMETHOD(ShowHelp)(
		/* [in ] */ HWND hwnd,
		/* [in ] */ LPOLESTR pszHelpFile,
		/* [in ] */ UINT uCommand,
		/* [in ] */ DWORD dwData,
		/* [in ] */ POINT ptMouse,
		/* [out] */ IDispatch __RPC_FAR *pDispatchObjectHit);
		STDMETHOD(ShowMessage)(
		/* [in ] */ HWND hwnd,
		/* [in ] */ LPOLESTR lpstrText,
		/* [in ] */ LPOLESTR lpstrCaption,
		/* [in ] */ DWORD dwType,
		/* [in ] */ LPOLESTR lpstrHelpFile,
		/* [in ] */ DWORD dwHelpContext,
		/* [out] */ LRESULT __RPC_FAR *plResult);
	END_INTERFACE_PART(DocHostShowUI)

/////////////////////////////////////////////////////////////////////////////
// IOleCommandTarget Interface
protected:
	BEGIN_INTERFACE_PART(OleCmdTarget, IOleCommandTarget)
		INIT_INTERFACE_PART(CHtmlViewExSite, OleCmdTarget)
	STDMETHOD(QueryStatus)(
	/* [unique][in] */ const GUID __RPC_FAR *pguidCmdGroup,
	/* [in] */ ULONG cCmds,
	/* [out][in][size_is] */ OLECMD __RPC_FAR prgCmds[	],
	/* [unique][out][in] */ OLECMDTEXT __RPC_FAR *pCmdText);
	STDMETHOD(Exec)(
	/* [unique][in] */ const GUID __RPC_FAR *pguidCmdGroup,
	/* [in] */ DWORD nCmdID,
	/* [in] */ DWORD nCmdexecopt,
	/* [unique][in] */ VARIANT __RPC_FAR *pvaIn,
	/* [unique][out][in] */ VARIANT __RPC_FAR *pvaOut);
	END_INTERFACE_PART(OleCmdTarget)

/////////////////////////////////////////////////////////////////////////////

	DECLARE_INTERFACE_MAP()
};

#undef	AFX_DATA
#define AFX_DATA

inline DWORD CHtmlViewExSite::GetHostInfo_Flags() const
	{return m_dwFlags;}

inline void CHtmlViewExSite::SetHostInfo_Flags(DWORD flags)
	{m_dwFlags = flags;}

inline DWORD CHtmlViewExSite::GetHostInfo_DblClk() const
	{ return m_dwDoubleClick;}

inline void CHtmlViewExSite::SetHostInfo_DblClk(DWORD DoubleClick)
	{m_dwDoubleClick = DoubleClick;}

inline void CHtmlViewExSite::UseCustomHelp(BOOL bSet)
	{m_bCustomHelp = bSet;}

inline void CHtmlViewExSite::UseCustomMessage(BOOL bSet)
	{m_bCustomMessage = bSet;}

inline void CHtmlViewExSite::UseCustomContextMenu(BOOL bSet)
	{m_bUseCustomContextMenu = bSet;}

inline void CHtmlViewExSite::UseAdvancedContextMenu(BOOL bSet)
	{m_bAdvancedContextMenuHandler = bSet;}

inline void CHtmlViewExSite::UseKillDialog(BOOL bSet)
	{m_bKillDialog = bSet;}

/////////////////////////////////////////////////////////////////////////////
// Insert the Html Form OccManager class here
// Beacause it directly uses this class
//
#ifndef __HTMLFORMOCCMANAGER__
#define __HTMLFORMOCCMANAGER__

/////////////////////////////////////////////////////////////////////////////
// CHtmlViewExOccManager class

#undef	AFX_DATA
#define AFX_DATA

//+++ : vc6 ł CHtmlViewExOccManager::CreateSite() ƌĂ΂邪A
//	vc7 ȍ~ł͑SĂ΂ȂB
//	ǂAMFĆ@COleControlContainer::CreateControlCommon ̏ς
//	vc6 ł́A CreateSiteKĂ΂\[XAvc7ȍ~ ܂
//	m_pWnd->CreateControlSite(this, &pSite,c)sÅ֐̒ł
//	CHtmlControlSite ̐΂ꂪpSiteɂȂAsꍇ
//	̂݁A CreateSite Ă΂󋵂ɕςĂB
//	NXCHtmlControlSite vc7̐V݂ŁÃt@CCHtmViewExSiteƓl
//	COleControlSite ṕivc6ł̕s[?)
//	ǂ CHtmlView  CreateControlSite I[o[ChāAœo^
//	̂悳.
//	ƂƂŁAvc7ȍ~ł́ACHtmlViewExOccManagergKvȂȂƎv.
//	 CPatriotView m_pHtmlViewExSiteQƂĂǁAm_pHtmlViewExSite
//	   CPatriotView ɎƂőΏ.


class CHtmlViewExOccManager : public COccManager
{
// Construction
public:
	CHtmlViewExSite* m_pHtmlViewExSite;

	CHtmlViewExOccManager()
	{
	  #if _MSC_VER < 1300	//+++ vc6 Ȃ猳X̏.
		m_pHtmlViewExSite = NULL;
	  #else //+++	vc7ȍ~ȂÃo[ϐ̂߂ɐƂ.
		ASSERT(0 && "VC7ȍ~ł͌Ă΂Ȃ"); 	//+++ m_pHtmlViewExSite = new CHtmlViewExSite(NULL);
	  #endif
	};

  #if _MSC_VER >= 1300	//+++ (vc6mfcȂJȂĂ? 悭킩Ă܂...)
	~CHtmlViewExOccManager()
	{
		delete m_pHtmlViewExSite;
	}
  #endif

// Implementation
public:
	virtual COleControlSite* CreateSite(COleControlContainer* pCtrlCont)
	{
		//if (m_pHtmlViewExSite)			//+++ Ô߂̃`FbN.
		//	delete m_pHtmlViewExSite;	//+++
		m_pHtmlViewExSite = new CHtmlViewExSite(pCtrlCont);
		return m_pHtmlViewExSite;
	}
};

#undef	AFX_DATA
#define AFX_DATA

#endif // __HTMLFORMOCCMANAGER__

/////////////////////////////////////////////////////////////////////////////

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // __HTMLVIEWEXSITE_H__
