//////////////////////////////////////////////////////////////////////
// PatriotGestureManager.cpp: CPatriotGestureManager NX̃Cve[V
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "MainFrm.h"
#include "GestureManager.h"
#include "PatriotGestureManager.h"
#include "IDMap.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// \z/
//////////////////////////////////////////////////////////////////////


CPatriotGestureManager::CPatriotGestureManager()
{
}

CPatriotGestureManager::CPatriotGestureManager(CString strPath)
{
}

CPatriotGestureManager::~CPatriotGestureManager()
{
}


/// }EXANṼ[h
void CPatriotGestureManager::LoadSetting()
{
	m_DrawLine	= g_Options.MouseDrawLine;
	m_LineColor = g_Options.MouseLineColor;
	m_MinPixel	= g_Options.MouseMinPixel;

	CGestureManager::LoadSetting();
}

/// C
BOOL CPatriotGestureManager::TranslateGesture(MSG* pMsg)
{
	// From DonutP
	if (pMsg->message != WM_RBUTTONDOWN) {
		return FALSE;
	}
/*
	// CDC
	CRect rect;AfxGetMainWnd()->GetClientRect(rect);
	CClientDC dcClient(AfxGetMainWnd());
	CBitmap bmpBuf;
	bmpBuf.CreateCompatibleBitmap(&dcClient , rect.Width() , rect.Height());
	CDC dcBuf;
	dcBuf.CreateCompatibleDC(&dcClient);
	dcBuf.SelectObject(&bmpBuf);
	dcBuf.BitBlt(0 , 0 , rect.Width() , rect.Height(), &dcClient , 0 , 0 , SRCCOPY);


	dcClient.BitBlt(0 , 0 , rect.Width() , rect.Height(), &dcBuf , 0 , 0 , SRCCOPY);
*/


	// ꗗ̕\
	if (g_Options.MouseDrawLine) {
		ShowAllCommand();
	}
	// }EXLv`t[
	CMDIFrameWnd* pFrame = (CMDIFrameWnd*)AfxGetMainWnd();
	HWND		  hWnd	 = pFrame->GetSafeHwnd();
	SetCapture(hWnd);

	MSG msg;msg.message = 0;
	CString strMouseCommand= _T("____ ");
	CPoint	ptRDown( LOWORD(pMsg->lParam) , HIWORD(pMsg->lParam) );
	::ClientToScreen(pMsg->hwnd, &ptRDown);
	CPoint	ptMove , ptMoveBefore;
	ptMoveBefore = ptRDown;

	DWORD	dwTime = 0;
	// [v
	do {
//		GetMessage(&msg , hWnd , 0 , 0);
//		if (GetCapture() != hWnd)	break;
		if (GetMessage(&msg, NULL, 0, 0) == FALSE) {
			continue;
		}
		//////////////////////////////////////////////////////////////////////
		// ړ
		if (msg.message == WM_MOUSEMOVE) {
			// ݂̃|Cg
			ptMove.x = LOWORD(msg.lParam);
			ptMove.y = HIWORD(msg.lParam);

			::ClientToScreen(msg.hwnd, &ptMove);
			if (abs(ptMove.y) < 60000 && abs(ptMove.x) <60000 &&
				(abs(ptMoveBefore.x-ptMove.x)>=m_MinPixel ||
				abs(ptMoveBefore.y-ptMove.y)>=m_MinPixel )){
			// ͂̔
			CString str= _T("");
			if (abs(ptMove.x-ptMoveBefore.x)>abs(ptMove.y-ptMoveBefore.y)) { // 
				if (ptMove.x-ptMoveBefore.x >0) {// E
					str= _T(" ");
				} else {//
					str= _T(" ");
				}
			} else { // c
				if (ptMove.y-ptMoveBefore.y >0) {// 
					str= _T(" ");
				} else {//
					str= _T(" ");
				}
			}
			if (m_DrawLine) {
				DrawLine(ptMoveBefore , ptMove);
			}

			DWORD dwTimeNow = ::GetTickCount();
			if (strMouseCommand.Right(3)!=str || (dwTimeNow-dwTime)>300) { // ɓ
				strMouseCommand += str;
				dwTime = dwTimeNow;
			}

			// Xe[^X
			UINT nFlags = UINT( msg.wParam );
			strMouseCommand.SetAt(0 , (nFlags & MK_LBUTTON) ? 'L' :'_');
			strMouseCommand.SetAt(1 , (nFlags & MK_MBUTTON) ? 'M' :'_');
			strMouseCommand.SetAt(2 , (nFlags & MK_SHIFT  ) ? 'S' :'_');
			strMouseCommand.SetAt(3 , (nFlags & MK_CONTROL) ? 'C' :'_');

			ptMoveBefore = ptMove;
			ShowMouseCommand(strMouseCommand);
			}
		//////////////////////////////////////////////////////////////////////
		// ԂBp
		} else if (g_Options.MouseTabWheel == 0 && msg.message == WM_MOUSEWHEEL) {
			ReleaseCapture();
			short zDelta = static_cast<short>( HIWORD(msg.wParam) );
			if (zDelta>0) {
				AfxGetMainWnd()->PostMessage( WM_COMMAND, ID_WINDOW_BACKTAB, 0 );
			} else {
				AfxGetMainWnd()->PostMessage( WM_COMMAND, ID_WINDOW_NEXTTAB, 0 );
			}
			CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
			pFrame->bGestured = TRUE;
			return TRUE;
		} else if (strMouseCommand.GetLength() == 5) {
			// L[PƂŃWFX`[̎s
			if (msg.message == WM_LBUTTONDOWN) {
				strMouseCommand.SetAt(0, 'L');
				ShowMouseCommand(strMouseCommand);
			} else if (msg.message == WM_LBUTTONUP) {
				if (DoMouseCommand(strMouseCommand)) { // s
					ReleaseCapture();
					return TRUE;
				}
				strMouseCommand.SetAt(0, '_');
				ShowMouseCommand(strMouseCommand);
			} else if (msg.message == WM_MBUTTONDOWN) {
				strMouseCommand.SetAt(1, 'M');
				ShowMouseCommand(strMouseCommand);
			} else if (msg.message == WM_MBUTTONUP) {
				if (DoMouseCommand(strMouseCommand)) { // s
					ReleaseCapture();
					return TRUE;
				}
				strMouseCommand.SetAt(1, '_');
				ShowMouseCommand(strMouseCommand);
			// KEYDOWN
			} else if (msg.message == WM_KEYDOWN  && ((int)msg.wParam == VK_SHIFT || (int)msg.wParam == VK_CONTROL)) {
				if ((int)msg.wParam == VK_SHIFT) {
					strMouseCommand.SetAt(2, 'S');
				} else {
					strMouseCommand.SetAt(3, 'C');
				}

				ShowMouseCommand(strMouseCommand);
				if (DoMouseCommand(strMouseCommand)) { // s
					ReleaseCapture();
					return TRUE;
				}
			}
			// KEYUP
			else if (msg.message == WM_KEYUP && ((int)msg.wParam == VK_SHIFT || (int)msg.wParam == VK_CONTROL)) {
				if ((int)msg.wParam == VK_SHIFT) {
					strMouseCommand.SetAt(2, '_');
				} else {
					strMouseCommand.SetAt(3, '_');
				}
				ShowMouseCommand(strMouseCommand);
			} else {//
				DispatchMessage(&msg);
			}
		} else {
		//	strMouseCommand.SetAt(1 , (nFlags & MK_MBUTTON) ? 'M' :'_');
		//	strMouseCommand.SetAt(2 , (nFlags & MK_SHIFT  ) ? 'S' :'_');
		//	strMouseCommand.SetAt(3 , (nFlags & MK_CONTROL) ? 'C' :'_');
			DispatchMessage(&msg);
		}
	} while (msg.message != WM_RBUTTONUP);

	ReleaseCapture();
	// G[ŏI
	if (msg.message != WM_RBUTTONUP) {
		return FALSE;
	}

	// Xe[^X
	UINT	nFlags = UINT( msg.wParam );
	strMouseCommand.SetAt(0 , (nFlags & MK_LBUTTON) ? 'L' :'_');
	strMouseCommand.SetAt(1 , (nFlags & MK_MBUTTON) ? 'M' :'_');
	strMouseCommand.SetAt(2 , (nFlags & MK_SHIFT  ) ? 'S' :'_');
	strMouseCommand.SetAt(3 , (nFlags & MK_CONTROL) ? 'C' :'_');
	// ĂȂ
	if (strMouseCommand== _T("____ " || (strMouseCommand == "L___ ")  && g_Options.MouseUseContext) ) {
		ShowMouseCommand( _T("") );
		::PostMessage(pMsg->hwnd , WM_RBUTTONUP  , pMsg->wParam , pMsg->lParam);
		return FALSE;
	}
	/*
	// y[Wړ𔻒
	BOOL bRefresh = TRUE;
	CString strTitle= _T("");
	CHtmlView* pView = NULL;
	if (pFrame->MDIGetActive()!=NULL) {
		pView = (CHtmlView*)pFrame->MDIGetActive()->GetActiveView();
		if (pView != NULL)
			strTitle = pView->GetLocationURL();
	}
	*/
	// R}hs
	int iResult = DoMouseCommand(strMouseCommand);
	/*
	// ^CgύXĂĕ`ʃIt
	if (pView != NULL && strTitle != pView->GetLocationURL())
		bRefresh = FALSE;
	*/
	// ʂXV
	if (m_DrawLine && strMouseCommand.GetLength() >5 /*&& bRefresh == TRUE
		&& ((iResult != ID_FILE_CLOSE && iResult != ID_VIEW_REFRESH) || pFrame->GetActiveView() == NULL)*/ ){
		if (pFrame->GetWindow(GW_CHILD)) {
			AfxGetMainWnd()->RedrawWindow(NULL , NULL , RDW_INVALIDATE | RDW_UPDATENOW | RDW_ERASE | RDW_ALLCHILDREN );
			/*
			HWND hBrowserWnd = pFrame->GetWindow(GW_CHILD)->GetSafeHwnd();
			::ShowWindow(hBrowserWnd , SW_HIDE);
			::ShowWindow(hBrowserWnd , SW_SHOW);
			*/
			// pFrame->UpdateWindow();
		} else {
			pFrame->RedrawWindow();
		}
		return TRUE;
	} else if (iResult != 0) { // s
		return TRUE;
	} else { // o^
		pFrame->SetMessageText( _T("") );
		// L+RM+RftHgŏ
		if (strMouseCommand.GetLength() == 5) {
			::PostMessage( pMsg->hwnd, WM_RBUTTONUP, pMsg->wParam, pMsg->lParam );
		}
		return FALSE;
	}
	//+++ return TRUE;		//+++ ɂ͂Ȃ.
}

/// }EXANV̕\
void CPatriotGestureManager::ShowMouseCommand(CString strMouseCommand)
{
	CString strCommand;
	CIDMap map;
	for (int i = 0; i < arrMouseAction.GetSize(); i++) {
		if (strMouseCommand == arrMouseAction.GetAt(i)) {
			strCommand+= _T(" [")+ map.Lookup(arrMouseCommand.GetAt(i)) +_T("]");
		}
	}
	((CFrameWnd*)AfxGetMainWnd())->SetMessageText(strMouseCommand + strCommand);
}

/// ANVꗗ̕\
void CPatriotGestureManager::ShowAllCommand()
{
	/*
	CIDMap map;
	CClientDC dc( AfxGetMainWnd() );

	CString str;
	for (int i = 0;i<arrMouseAction.GetSize();i++) {
		str+= _T(" [")+ map.Lookup(arrMouseCommand.GetAt(i)) +_T("]") + arrMouseAction.GetAt(i)+_T("\n");
	}
	CSize size = dc.GetTextExtent(str);
	CRect rect;AfxGetMainWnd()->GetFocus()->GetWindowRect(rect);
/*
	COLORREF color = m_LineColor;
	CPen pen(PS_SOLID , 1 , color);
	CPen* oldPen = dc.SelectObject(&pen);

	CBrush brush;
	brush.CreateSolidBrush(color);
	CBrush* oldBrush = dc.SelectObject(&brush);

	dc.MoveTo(ptFrom.x , ptFrom.y);
	dc.LineTo(ptTo.x   , ptTo.y  );
	dc.FillRect(CRect(ptTo.x-2 , ptTo.y-2 , ptTo.x+2 , ptTo.y+2), &brush);

	dc.SelectObject(oldPen);
	dc.SelectObject(oldBrush);

	CBrush brush;
	brush.CreateSolidBrush( ::GetSysColor(COLOR_INFOBK) );
	CBrush* oldBrush = dc.SelectObject(&brush);

	dc.SetBkColor( ::GetSysColor(COLOR_INFOBK) );
	dc.SetTextColor( ::GetSysColor(COLOR_INFOTEXT) );
	dc.DrawText( str , rect, DT_NOCLIP);
	dc.FillRect(CRect( rect.left, rect.top, rect.left+size.cx, rect.top+size.cy), &brush);


	dc.SelectObject(oldBrush);
	*/
}
