// EditToolbarDlg.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "OptionDlg.h"
#include "EditToolbarDlg.h"
#include "..\burapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CEditToolbarDlg

IMPLEMENT_DYNAMIC(CEditToolbarDlg, CPropertySheet)

CEditToolbarDlg::CEditToolbarDlg(UINT nIDCaption, CWnd* pParentWnd, UINT iSelectPage)
	: CPropertySheet(nIDCaption, pParentWnd, iSelectPage)
	, m_hIcon(0)
	, m_ImageList()
	, pageToolbar()
	, pageToolbarEdit()
{
	AddControlPages();
}

CEditToolbarDlg::CEditToolbarDlg(LPCTSTR pszCaption, CWnd* pParentWnd, UINT iSelectPage)
	:CPropertySheet(pszCaption, pParentWnd, iSelectPage)
{
	AddControlPages();
}

CEditToolbarDlg::~CEditToolbarDlg()
{
}

void CEditToolbarDlg::AddControlPages()
{ // vpeBV[g̒ǉ
	// \[X̃pX擾
	TCHAR pszBuffer[MAX_PATH];
	::SendMessage( AfxGetMainWnd()->GetSafeHwnd() , BURAPI_GET_SPECIAL_FOLDER , BURA_SPFOLDER_RESOURCE, reinterpret_cast<LPARAM>(pszBuffer) );
	CString strResPath = pszBuffer;

	// c[o[̃C[Wǂ݂
	CBitmap BMP_Tool;
	HBITMAP BMP_buf;
	m_ImageList.Create(16 , 16 , ILC_MASK | ILC_COLOR16 , 0 , 30);
	BMP_buf = ( HBITMAP )::LoadImage(NULL , strResPath +  _T("\\toolhot.bmp") , IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	BMP_Tool.Attach(BMP_buf);
	m_ImageList.Add(&BMP_Tool , RGB(255, 0, 255));

	// e_CAOɃC[WXgn
	pageToolbar.m_pImageList = &m_ImageList;
	pageToolbarEdit.m_pImageList = &m_ImageList;

	// vpeBV[gǉ
	AddPage(&pageToolbar);
	AddPage(&pageToolbarEdit);
}

BEGIN_MESSAGE_MAP(CEditToolbarDlg, CPropertySheet)
	//{{AFX_MSG_MAP(CEditToolbarDlg)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CEditToolbarDlg bZ[W nh
void CEditToolbarDlg::OnOK()
{
	for (int i = 0;i<GetPageCount();i++)
		GetPage(i)->SendMessage(WM_COMMAND , IDOK);
	EndDialog(IDOK);
}

BOOL CEditToolbarDlg::OnInitDialog()
{
	BOOL bResult = CPropertySheet::OnInitDialog();

	return bResult;
}
