// PageAddress.cpp : Cve[V t@C
//

#include "stdafx.h"
#include "optiondlg.h"
#include "PageAddress.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPageAddress vpeB y[W

IMPLEMENT_DYNCREATE(CPageAddress, CPropertyPage)

CPageAddress::CPageAddress() : CPropertyPage(CPageAddress::IDD)
{
	//{{AFX_DATA_INIT(CPageAddress)
	m_HistoryCount	= 0;
	m_AutoComplete	= FALSE;
	m_GoHistory 	= FALSE;
	m_AddSendUrl	= FALSE;
	m_Ctrl1 		= _T("");
	m_Ctrl2 		= _T("");
	m_Ctrl3 		= _T("");
	m_ShowIcon		= FALSE;
	//}}AFX_DATA_INIT
}

CPageAddress::~CPageAddress()
{
}

void CPageAddress::DoDataExchange(CDataExchange* pDX)
{
	CPropertyPage::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPageAddress)
	DDX_Text(pDX, IDC_EDIT3, m_HistoryCount);
	DDV_MinMaxUInt(pDX, m_HistoryCount, 0, 255);
	DDX_Check(pDX, IDC_CHECK1, m_AutoComplete);
	DDX_Check(pDX, IDC_CHECK3, m_GoHistory);
	DDX_Check(pDX, IDC_CHECK5, m_AddSendUrl);
	DDX_CBString(pDX, IDC_COMBO1, m_Ctrl1);
	DDX_CBString(pDX, IDC_COMBO2, m_Ctrl2);
	DDX_CBString(pDX, IDC_COMBO3, m_Ctrl3);
	DDX_Check(pDX, IDC_CHECK4, m_ShowIcon);
	//}}AFX_DATA_MAP
}


BEGIN_MESSAGE_MAP(CPageAddress, CPropertyPage)
	//{{AFX_MSG_MAP(CPageAddress)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CPageAddress bZ[W nh

BOOL CPageAddress::OnInitDialog()
{
	CPropertyPage::OnInitDialog();
	// sendstr.ini烊Xgǂݍ
	CComboBox* pCombo1 = (CComboBox*)GetDlgItem(IDC_COMBO1);
	CComboBox* pCombo2 = (CComboBox*)GetDlgItem(IDC_COMBO2);
	CComboBox* pCombo3 = (CComboBox*)GetDlgItem(IDC_COMBO3);

	TCHAR chrBuf[1024*32];
	::GetPrivateProfileSectionNames(chrBuf, 1024*32, g_Options.strOptionPath + _T("\\sendurl.ini") );

	LPTSTR pChr = chrBuf;
	while (*pChr != '\0'){
		pCombo1->AddString(pChr);
		pCombo2->AddString(pChr);
		pCombo3->AddString(pChr);
		pChr += lstrlen(pChr) + 1;
	}

	pCombo1->AddString( _T("") );
	pCombo2->AddString( _T("") );
	pCombo3->AddString( _T("") );

	::GetPrivateProfileSectionNames(chrBuf, 1024*32, g_Options.strOptionPath + _T("\\sendstr.ini") );
	pChr = chrBuf;
	while (*pChr != '\0'){
		pCombo1->AddString(pChr);
		pCombo2->AddString(pChr);
		pCombo3->AddString(pChr);
		pChr += lstrlen(pChr) + 1;
	}
	// AhXo[
	m_ShowIcon		= g_Options.AddressShowIcon;
	m_GoHistory 	= g_Options.AddressGoHistory;
	m_AddSendUrl	= g_Options.AddressAddSendurl;
	m_HistoryCount	= g_Options.AddressHistoryCount;
	m_AutoComplete	= g_Options.AddressAutoComplete;
	m_Ctrl1 		= g_Options.strAddressCtrl1;
	m_Ctrl2 		= g_Options.strAddressCtrl2;
	m_Ctrl3 		= g_Options.strAddressCtrl3;
	UpdateData(FALSE);
	return TRUE;  // Rg[ɃtH[JXݒ肵ȂƂA߂l TRUE ƂȂ܂
				  // O: OCX vpeB y[W̖߂l FALSE ƂȂ܂
}

void CPageAddress::OnOK()
{ // ݒۑ
	// AhXo[
	g_Options.AddressShowIcon		= m_ShowIcon;
	g_Options.AddressAutoComplete	= m_AutoComplete;
	g_Options.AddressGoHistory		= m_GoHistory;
	g_Options.AddressAddSendurl 	= m_AddSendUrl;
	g_Options.AddressHistoryCount	= m_HistoryCount;
	g_Options.strAddressCtrl1		= m_Ctrl1;
	g_Options.strAddressCtrl2		= m_Ctrl2;
	g_Options.strAddressCtrl3		= m_Ctrl3;
	CPropertyPage::OnOK();
}
