/////////////////////////////////////////////////////////////////////////////
// PatriotSidebar.cpp : Cve[V t@C
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "patriot.h"
#include "RotkLeftDlg.h"
#include "MainFrm.h"
#include "PatriotSidebar.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CPatriotSidebar _CAO


CPatriotSidebar::CPatriotSidebar(CWnd* pParent /*=NULL*/)
	: CRotkLeftDlg()
	, m_bVisible(0)
	, m_Font()
	, m_Images()
	, m_wndTab()
	, m_wndCloseBtn()
	, TreeFavorites()
	, TreeUrllist()
	, TreeHistory()
	, TreeTab()
{
	//{{AFX_DATA_INIT(CPatriotSidebar)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_INIT
}

void CPatriotSidebar::DoDataExchange(CDataExchange* pDX)
{
	CRotkLeftDlg::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CPatriotSidebar)
		//  - ClassWizard ͂̈ʒuɃ}bsOp̃}Nǉ܂͍폜܂B
	//}}AFX_DATA_MAP
}
BEGIN_MESSAGE_MAP(CPatriotSidebar, CRotkLeftDlg)
	//{{AFX_MSG_MAP(CPatriotSidebar)
	ON_WM_SIZE()
	ON_WM_MOUSEWHEEL()
	ON_WM_LBUTTONDBLCLK()
	ON_WM_MOUSEMOVE()
	ON_NOTIFY(TCN_SELCHANGE, IDC_TAB1, OnSelchangeTab1)
	ON_WM_LBUTTONUP()
	ON_WM_CONTEXTMENU()
	ON_WM_DESTROY()
	ON_COMMAND(IDC_BUTTON1, OnCloseButton)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()


/////////////////////////////////////////////////////////////////////////////
// CPatriotSidebar \bh

/// \z
BOOL CPatriotSidebar::Create(CWnd *pParentWnd , UINT nIDTemplate , UINT nID , int Width)
{
	if (!CRotkLeftDlg::Create(pParentWnd , nIDTemplate , nID , Width)) {
		return false;
	}
	FormLoad();
	return true;
}

/// Rg[
void CPatriotSidebar::FormLoad()
{
	CRect rect;
	GetClientRect(rect);

	// TCho[̃^u
	m_wndTab.Create(TCS_TOOLTIPS | WS_CHILD | WS_CLIPCHILDREN | WS_VISIBLE | WS_TABSTOP | (g_Options.SidebarTabUnder ? TCS_BOTTOM : NULL) | TCS_HOTTRACK | TCS_FIXEDWIDTH | TCS_FOCUSNEVER, rect, this, IDC_TAB1);// | TCS_OWNERDRAWFIXED
	ModifyStyle( 0, WS_CLIPCHILDREN );
	m_wndTab.SetPadding( CSize(0, 3) );
	m_wndTab.SetItemSize( CSize(24 , 18) );

	CMainFrame* pFrame = (CMainFrame*)GetParent();
	rect.left	 = 4;
	rect.top	 = 6;
  #if 0 //+++ ߂....
	if (rect.Width() > 4+10)
		rect.right	-= 10;
	else if (rect.Width() <= 4)
		rect.right = 5;
	if (rect.Height() > 6+26)
		rect.bottom -= 26;//TVS_NOTOOLTIPS
	else if (rect.Height() <= 6)
		rect.bottom = 7;
  #else
	rect.right	-= 10;
	rect.bottom -= 26;//TVS_NOTOOLTIPS
  #endif

	// epl\z
	TreeFavorites.Create( LBS_NOTIFY | WS_VISIBLE | TVS_HASBUTTONS | TVS_HASLINES | TVS_TRACKSELECT | WS_TABSTOP | TVS_SINGLEEXPAND | TVS_SHOWSELALWAYS
							  , rect, &m_wndTab , NULL);
	TreeFavorites.ModifyStyleEx( 0, WS_EX_CLIENTEDGE );

	TreeUrllist.Create( LBS_NOTIFY | WS_VISIBLE | TVS_HASBUTTONS | TVS_HASLINES | TVS_TRACKSELECT | WS_TABSTOP | TVS_SINGLEEXPAND | TVS_SHOWSELALWAYS
							, rect, &m_wndTab , NULL);
	TreeUrllist.ModifyStyleEx( 0, WS_EX_CLIENTEDGE | TVS_SINGLEEXPAND );

	TreeHistory.Create( LBS_NOTIFY | WS_VISIBLE | TVS_HASBUTTONS | TVS_HASLINES | TVS_TRACKSELECT | WS_TABSTOP | TVS_SINGLEEXPAND | TVS_SHOWSELALWAYS , rect, &m_wndTab , NULL);
	TreeHistory.ModifyStyleEx( NULL, WS_EX_CLIENTEDGE | TVS_SINGLEEXPAND );

	TreeTab.Create( LVS_SHOWSELALWAYS | LVS_REPORT | LVS_SHAREIMAGELISTS | LVS_NOCOLUMNHEADER, rect, &m_wndTab, NULL );
	TreeTab.ModifyStyleEx( NULL, WS_EX_CLIENTEDGE );
	TreeTab.pTabs = &pFrame->m_Tabs;
	//TreeTab.SetImageList(&TreeTab.m_Images , LVSIL_SMALL);
	//todo: 1.4.00 ܂ł̉B@\
	TreeTab.ShowWindow(SW_HIDE);

	// {^
	rect.left	= 2;
	rect.top	= 2;
	rect.bottom = 17;
	rect.right	= 17;
	//m_wndCloseBtn.Create(&m_wndTab, rect, IDC_BUTTON1);
	//m_wndCloseBtn.ShowWindow(SW_SHOW);

	// tHgݒ
	// w肵傫̃tHg쐬
	/*
	CClientDC dc(this);
	m_Font.DeleteObject();	// U폜
	m_Font.CreatePointFont(100, _T("MS UI Gothic")	, NULL);
	CFont* pOldFont = dc.SelectObject(&m_Font);
	*/
	/*
	HFONT hFont = (HFONT)GetStockObject(DEFAULT_GUI_FONT);
	if (hFont == NULL) {
		hFont = (HFONT)GetStockObject(SYSTEM_FONT);
	}
	CFont* pFont = CFont::FromHandle(hFont);
	*/
	NONCLIENTMETRICS ncm;
	ncm.cbSize = sizeof(NONCLIENTMETRICS);
	VERIFY(SystemParametersInfo(SPI_GETNONCLIENTMETRICS, sizeof(NONCLIENTMETRICS), &ncm, 0));
	m_Font.CreateFontIndirect(&ncm.lfMessageFont);
	CFont* pFont = &m_Font;

	m_wndTab.SetFont(pFont, FALSE);
	TreeFavorites.SetFont(pFont, FALSE);
	TreeUrllist.SetFont(pFont, FALSE);
	TreeHistory.SetFont(pFont, FALSE);

	// ݒǂݍ
	m_bVisible			 = AfxGetApp()->GetProfileInt( _T("Window"), _T("SidebarVisible"), TRUE);
	int SideWidth		 = AfxGetApp()->GetProfileInt( _T("Window"), _T("SidebarWidth")  , 200 );
	g_Options.CurSidebar = AfxGetApp()->GetProfileInt( _T("Window"), _T("SidebarCur")	 , 0   );

	SetWidth(SideWidth);
	SetSidebarIndex(g_Options.CurSidebar);
	m_wndTab.SetCurSel(g_Options.CurSidebar);

	if (!m_bVisible) {
		ShowWindow(SW_HIDE);
	}
}

/// ANeBuȃplԂ
CWnd* CPatriotSidebar::GetActiveBar()
{
	CWnd* pTreeCtrl = NULL;
	switch(g_Options.CurSidebar){
	case 0:
		pTreeCtrl = &TreeFavorites;
		break;
	case 1:
		pTreeCtrl = &TreeUrllist;
		break;
	case 2:
		pTreeCtrl = &TreeHistory;
		break;
	case 3:
		pTreeCtrl = &TreeTab;
		break;
	}
	return pTreeCtrl;
}

/// ANeBuȃplݒ
void CPatriotSidebar::SetSidebarIndex(int Index)
{
	// Âpl擾
	CWnd* pTreeOldCtrl = GetActiveBar();
	if (!pTreeOldCtrl) {
		return;
	}

	// Vpl̗̈ݒ
	CRect rect;
	GetClientRect( rect );
	rect.left	 = 1;
	rect.top	 = 1;
	rect.right	-= 9;
	rect.bottom -= 26;

	if (!g_Options.SidebarTabUnder) { // ^u
		rect.top	+= 21;
		rect.bottom += 20;
	}
	m_wndTab.SetCurSel(Index);
	g_Options.CurSidebar = Index;


	// Vpl\
	CWnd* pTreeCtrl = GetActiveBar();
	pTreeCtrl->MoveWindow(rect);
	pTreeCtrl->ShowWindow(SW_SHOW);
	// ÂplB
	if ( pTreeCtrl != pTreeOldCtrl ) {
		pTreeOldCtrl->ShowWindow(SW_HIDE);
	}
	pTreeCtrl->SetFocus();

	// f[^ǂݍ
	LoadData();
}

/// f[^ǉ
void CPatriotSidebar::LoadData()
{
	if (m_bVisible || IsWindowVisible()) {
		switch( g_Options.CurSidebar ){
		case 0:
			TreeFavorites.LoadData();
			break;
		case 1:
			TreeUrllist.LoadData();
			break;
		case 2:
			TreeHistory.LoadData();
			break;
		case 3:
			TreeTab.LoadData();
			break;
		}
	}
	// 摜̃[h
	// łɓǍς݂H
	static bool flag = true;
	if ( flag ) {
		flag = false;
	} else {
		return;
	}

	// C[W̃[h
	CBitmap BMP_Tool;
	HBITMAP BMP_baf;
	m_Images.Create(16, 16, ILC_MASK | ILC_COLOR32, 0, 30);
	BMP_baf = ( HBITMAP )::LoadImage(NULL, g_Options.strAppPath + _T("\\res\\sidebar.bmp"), IMAGE_BITMAP, 0, 0, LR_LOADFROMFILE);
	BMP_Tool.Attach( BMP_baf );
	m_Images.Add( &BMP_Tool, RGB(255, 0, 255) );
	BMP_Tool.Detach();
	BMP_Tool.DeleteObject();

	TreeFavorites.SetImageList( &m_Images, TVSIL_NORMAL );
	TreeHistory.SetImageList( &m_Images, TVSIL_NORMAL );
	TreeUrllist.SetImageList( &m_Images, TVSIL_NORMAL );

	m_wndTab.SetImageList( &m_Images );
	m_wndTab.InsertItem( TCIF_IMAGE, 0, _T(""), 12, NULL );
	m_wndTab.InsertItem( TCIF_IMAGE, 1, _T(""), 13, NULL );
	m_wndTab.InsertItem( TCIF_IMAGE, 2, _T(""), 14, NULL );
	m_wndTab.InsertItem( TCIF_IMAGE, 3, _T(""), 15, NULL );
}


/////////////////////////////////////////////////////////////////////////////
// CPatriotSidebar bZ[W nh


BOOL CPatriotSidebar::PreTranslateMessage(MSG* pMsg)
{
	if (pMsg->message == WM_MOUSEWHEEL && IsWindowVisible()) {
		CRect rect;GetActiveBar()->GetWindowRect(rect);
		if (!rect.PtInRect(pMsg->pt)) {
			SendMessage(WM_MOUSEWHEEL , pMsg->wParam , pMsg->lParam);
			return TRUE;
		}
	}
	// ANZ[^񂾂[h
	static HACCEL hAccel = HACCEL(0);
	if (hAccel == HACCEL(0)) {
		hAccel = ::LoadAccelerators(::AfxGetApp()->m_hInstance, MAKEINTRESOURCE(IDR_SIDEBAR));
		ASSERT(hAccel != HACCEL(0));
	}
	// API  TranslateAccelerator Ă
	if ( (pMsg->message == WM_KEYDOWN || pMsg->message == WM_SYSKEYDOWN ) && pMsg->wParam != VK_TAB) {
		if (pMsg->wParam == VK_DELETE && g_Options.CurSidebar < 2 && ((CTreeCtrl*)GetActiveBar())->GetEditControl( ) == NULL) {
			GetActiveBar()->SendMessage(WM_COMMAND , ID_SIDEBAR_DELETE);
			return TRUE;
		} else if (::TranslateAccelerator(GetActiveBar()->GetSafeHwnd(), hAccel, pMsg)) {
			return TRUE;
		}
	}
	return CRotkLeftDlg::PreTranslateMessage(pMsg);
}

/// Rg[̃TCYύX
void CPatriotSidebar::OnSize(UINT nType, int cx, int cy)
{
	CRotkLeftDlg::OnSize(nType, cx, cy);

	// ^ũTCYύX
	CWnd* pTab = GetDlgItem(IDC_TAB1);
	CRect rect( 0, 2, cx-6, cy - 2 );
	if (pTab != NULL) {
		pTab->MoveWindow(rect);

		// {^̈ʒuύX
		CRect rect3(cx - 24, 2, cx - 7, 18);
		CWnd* pButton = pTab->GetDlgItem(IDC_BUTTON1);
		if (pButton) {
			pButton->MoveWindow(rect3);
		}
	}

	// o[̈ʒuύX
	CRect rect2( 1, 1, cx - 8, cy - 26 );
	if (!g_Options.SidebarTabUnder) { // ^u
		rect2.top	 += 21;
		rect2.bottom += 20;
	}

	CWnd* pTreeCtrl = GetActiveBar();
	if ( ::IsWindow(pTreeCtrl->m_hWnd) ) {
		pTreeCtrl->MoveWindow( rect2 );
		TreeTab.SetColumnWidth( 0 , rect2.Width() - 4 );
	}

	if (!g_Options.SidebarNeglectWidth) {
		CMainFrame* pFrame = (CMainFrame*)GetParent();
		pFrame->TabmodeResize();
	}
}

/// ^u̕ύX
void CPatriotSidebar::OnSelchangeTab1(NMHDR* pNMHDR, LRESULT* pResult)
{
	CTabCtrl* pTab = (CTabCtrl*)GetDlgItem(IDC_TAB1);
	SetSidebarIndex(pTab->GetCurSel());
}

void CPatriotSidebar::OnLButtonUp(UINT nFlags, CPoint point)
{
	CRotkLeftDlg::OnLButtonUp(nFlags , point);
	/*
	m_OldWidth = GetWidth();
	if (g_Options.TabMode &&(point.x >= GetWidth()-9 || point.x <= 7)) { // ^u[h
		CMainFrame* pFrame = (CMainFrame*)AfxGetMainWnd();
		pFrame->TabmodeResize();
	}
	*/
}

/// ENbNj[
void CPatriotSidebar::OnContextMenu(CWnd* pWnd, CPoint point)
{
	switch(g_Options.CurSidebar){
	case 0:
		TreeFavorites.OnContextMenu( pWnd, point );
		break;
	case 1:
		TreeUrllist.OnContextMenu( pWnd, point );
		break;
	case 2:
		TreeHistory.OnContextMenu( pWnd, point );
		break;
	}
}

/// zC[̉]
BOOL CPatriotSidebar::OnMouseWheel(UINT nFlags, short zDelta, CPoint pt)
{
	CRect rect;
	GetDlgItem(IDC_TAB1)->GetWindowRect(rect);
	if (rect.PtInRect(pt)) { // ^u
		int Index = g_Options.CurSidebar;
		if (zDelta>0) {
			Index--;
		} else {
			Index++;
		}

		if (Index == 4) {
			SetSidebarIndex(0);
		} else if (Index == -1) {
			SetSidebarIndex(3);
		} else {
			SetSidebarIndex(Index);
		}
	}
	return CRotkLeftDlg::OnMouseWheel(nFlags, zDelta, pt);
}

/// ĕ`
void CPatriotSidebar::OnLButtonDblClk(UINT nFlags, CPoint point)
{
	CRotkLeftDlg::OnLButtonDblClk(nFlags, point);
}

/// }EXړ
void CPatriotSidebar::OnMouseMove(UINT nFlags, CPoint point)
{
	CRotkLeftDlg::OnMouseMove(nFlags, point);
}

/// j
void CPatriotSidebar::OnDestroy()
{
	CRotkLeftDlg::OnDestroy();
	m_Images.DeleteImageList();
//	m_Font.DeleteObject();
}

/// 
void CPatriotSidebar::OnCloseButton()
{
	AfxGetMainWnd()->SendMessage(WM_COMMAND, ID_VIEW_SIDEBAR);
}
